/**************************************************************
***** Creates APPX Connector service process for Windows, *****
************** Linux, and Mac operating systems ***************
**************************************************************/

//Detects OS and sets the Service variable accordingly.
switch(process.platform){
	case 'win32':
		var Service = require('node-windows').Service; break;
	case 'linux':
		var Service = require('node-linux').Service; break;
	case 'darwin':
		var Service = require('node-mac').Service; break;
}

//Create new service object
var svc = new Service({
	name: 'appxConnector',
	description: 'Connector that allows appx client to talk to server.',
	script: 'appxConnector.js',
	
	//Set variable so appxConnector.js knows where to push files to.
	env:[{
		name: "APPX_CONNECTOR_DIR",
		value: require('path').resolve(__dirname)
	},{
		name: "NODE_ENV",
		value: "production"
	}]
});
	
//Installs service
svc.install();

//Wait 5 seconds to start service to make sure service has finished installing.
setTimeout(function(){
	svc.start();
}, 5000);
